import { ExplainPlan } from '@mongodb-js/explain-plan-helper';
import type { Action, AnyAction, Reducer } from 'redux';
import type { ThunkAction } from 'redux-thunk';
import type { ExplainPlanModalServices, OpenExplainPlanModalEvent } from '.';
export declare function isAction<A extends AnyAction>(action: AnyAction, type: A['type']): action is A;
export type SerializedExplainPlan = ReturnType<ExplainPlan['serialize']>;
export type ExplainPlanModalState = {
    namespace: string;
    isDataLake: boolean;
    error: string | null;
    isModalOpen: boolean;
    status: 'initial' | 'loading' | 'ready' | 'error';
    explainPlan: SerializedExplainPlan | null;
    rawExplainPlan: unknown | null;
    explainPlanFetchId: number;
};
type ExplainPlanModalThunkAction<R, A extends Action = AnyAction> = ThunkAction<R, ExplainPlanModalState, ExplainPlanModalServices, A>;
export declare const INITIAL_STATE: ExplainPlanModalState;
export declare const reducer: Reducer<ExplainPlanModalState>;
export declare const openExplainPlanModal: (event: OpenExplainPlanModalEvent) => ExplainPlanModalThunkAction<Promise<void>>;
export declare const closeExplainPlanModal: () => ExplainPlanModalThunkAction<void>;
export declare const openCreateIndexModal: () => ExplainPlanModalThunkAction<void>;
export {};
//# sourceMappingURL=explain-plan-modal-store.d.ts.map